#include <cmath>
#include "dcc_log.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++

static int cs[10240]; 
static int cs_c=0; 
static double fds[10240]; 
static int fds_c=0; 
static int ids[10240]; 
static int ids_c=0; 
 void rhs(double* f, double* x, double* u, int &n, int & m, int & n_T, int & n_Theta, int & n_Tau)
 //$ad indep x
 //$ad dep f 
 {
  // f[n] : out, right hand side of DAE
  // x[n] : in, state vector
  //		x[0]=T_in0, x[1]=T_LTin, x[2]=Theta_in_pr, x[3]=Theta_out_pr, x[4]=Theta_in_sec, x[5]=Theta_out_sec, x[6]=Tau_in_pr, x[7]=Tau_out_pr, 
  //		x[8]=Tau_in_sec, x[9]=Tau_out_sec, x[10]=v, x[11]=v_g, x[12]=n_F, x[13]=delta_z, x[14]=delta_x1, x[15]=delta_x2,
  //		x[16 : 16+n_T-1]= T (Temp storage tank), x[16+n_T : 16+n_T+n_Theta-1]= Theta_pr (Temp heat exchanger part 1),
  //		x[16+n_T+n_Theta : 16+n_T+2*n_Theta-1]= Theta_sec (Temp heat exchanger part 2),
  //		x[16+n_T+2*n_Theta : 16+n_T+2*n_Theta+n_Tau-1]= Tau_pr (Temp burner part 1),
  //		x[16+n_T+2*n_Theta+n_Tau : 16+n_T+2*n_Theta+2*n_Tau-1]= Tau_w (Temp burner part w),
  //		x[16+n_T+2*n_Theta+2*n_Tau : 16+n_T+2*n_Theta+3*n_Tau-1]= Tau_sec (Temp burner part 2),
  // p[m] : in, parameter vector
  //		cfr function initializeParameters
  // n    : in, dimension of f and x
  // m	  : in, dimension of p
  int i=0;
  double exp_1=0;
  int index_1=0;
  int index_2=0;
  int index_3=0;
  int index_4=0;
  int run_index_1=0;
  int run_index_2=0;
  int run_index_3=0;
  int cond=0;
  int cond_1_min_1=0;
  int cond_2=0;
  int cond_3=0;
  int cond_4=0;
  int cond_5=0;
  int cond_6=0;
 f[0] = x[0] - x[5];
 f[1] = x[1] - 285.0;
 f[2] = x[2] - x[9];
 f[3] = x[3] - x[16+n_T];
 f[4] = x[4] - x[1];
 f[5] = x[5] - x[16+n_T+2*n_Theta-1];
  exp_1=u[32];
  f[6] = x[6] - u[29]/(pow(x[12],exp_1) + u[30]) - u[31];
 //  f[6] = x[6] - u[29]/(pow(x[12],u[32]) + u[30]) - u[31]; 
 f[7] = x[7] - x[16+n_T+2*n_Theta];
 f[8] = x[8] - x[3];
 f[9] = x[9] - x[16+n_T+2*n_Theta+3*n_Tau-1];
 f[10]= x[10]- (u[12]-u[13])/u[11];
 f[11]= x[11]- u[23] * x[12]/100.0;
 f[12]= x[12]- u[25];
 f[13]= x[13]- u[8]/(n_T-1);
 f[14]= x[14]- u[9]/(n_Theta-1);
 f[15]= x[15]- u[10]/(n_Tau-1);


 cond = 16+n_T-1;
 for(i=17;i<cond; i++){
  f[i] = u[1]/(u[2]*u[3]) * (x[i+1] - 2.0*x[i] + x[i-1])/pow(x[13],2) - x[10]*(x[i]-x[i-1])/(x[13]) - 4.0*u[4]/(u[7]*u[2]*u[3])*(x[i]-u[0]);
 }

 f[16] = x[16]-x[0];
 f[16+n_T-1] = u[1]*(x[16+n_T-1]-x[16+n_T-2])/x[13] - u[2]*u[3]*u[13]/u[11]*(x[1]-x[16+n_T-1]) + u[6]*(x[16+n_T-1]-u[0]);



  cond_2 = 16+n_T+n_Theta-1;
  ///////////////////
  for(i=16+n_T+1;i<cond_2;i++){
  f[i] = u[14]*(x[i+1]-x[i])/(x[14]) - 2.0*u[15]*u[18]/(u[2]*u[3]*(pow(u[16],2.0)-pow(u[18],2.0)))*(x[i]-x[n_Theta+i]);
  }


 f[16+n_T] = u[14]*(x[16+n_T+1]-x[16+n_T])/x[14] - 2.0*u[15]*u[18]/(u[2]*u[3]*(pow(u[16],2.0)-pow(u[18],2.0)))*(x[16+n_T]-x[16+n_T+n_Theta]);
 f[16+n_T+n_Theta-1] = x[16+n_T+n_Theta-1] - x[2];



  //////////////////////
  cond_3 = 16+n_T+2*n_Theta-1;
  for(i=16+n_T+n_Theta+1; i<cond_3; i++){
  f[i] = 0-u[12]*(x[i]-x[i-1])/(x[14]) + 2.0*u[15]/(u[2]*u[3]*u[17])*(x[i-n_Theta]-x[i]);
  }

 f[16+n_T+2*n_Theta-1] = 0-u[12]*(x[16+n_T+2*n_Theta-1]-x[16+n_T+2*n_Theta-2])/x[14] + 2.0*u[15]/(u[2]*u[3]*u[17])*(x[16+n_T+n_Theta-1]-x[16+n_T+2*n_Theta-1]);
 f[16+n_T+n_Theta] = x[16+n_T+n_Theta] - x[4];


  ///////////////////////


  cond_4 = 16+n_T+2*n_Theta+n_Tau-1;

  for(i=16+n_T+2*n_Theta+1;i<cond_4;i++){
  f[i] = x[11] * (x[i+1]-x[i])/(x[15]) - u[19]*(x[i]-x[n_Tau+i]);
  }

 f[16+n_T+2*n_Theta] = x[11] * (x[16+n_T+2*n_Theta+1]-x[16+n_T+2*n_Theta])/x[15] - u[19]*(x[16+n_T+2*n_Theta]-x[16+n_T+2*n_Theta+n_Tau]);
 f[16+n_T+2*n_Theta+n_Tau-1] = x[16+n_T+2*n_Theta+n_Tau-1] - x[6];


  ///////////////////////

  cond_5 = 16+n_T+2*n_Theta+2*n_Tau;


  for(i=16+n_T+2*n_Theta+n_Tau;i<cond_5;i++){
  f[i] = u[19]/u[21] * (x[i-n_Tau]-x[i]) - u[20]/u[22]*(x[i]-x[i+n_Tau]);
  }
  ///////////////////////
  cond_6= 16+n_T+2*n_Theta+3*n_Tau-1;

  for (i=16+n_T+2*n_Theta+2*n_Tau+1; i<cond_6; i++){
  f[i] =0 -u[14] * (x[i]-x[i-1])/(x[15]) + u[20]*(x[i-n_Tau]-x[i]);
  }

 f[16+n_T+2*n_Theta+3*n_Tau-1] = 0-u[14] * (x[16+n_T+2*n_Theta+3*n_Tau-1]-x[16+n_T+2*n_Theta+3*n_Tau-2])/x[15] + u[20]*(x[16+n_T+2*n_Theta+2*n_Tau-1]-x[16+n_T+2*n_Theta+3*n_Tau-1]);
 f[16+n_T+2*n_Theta+2*n_Tau] = x[16+n_T+2*n_Theta+2*n_Tau] - x[8];

 }

void a1_rhs(int& bmode_1, double* f, double* a1_f, double* x, double* a1_x, double* u, double* a1_u, int& n, int& m, int& n_T, int& n_Theta, int& n_Tau)
//$ad indep x a1_x a1_f
//$ad dep f a1_x
{
   int i=0; 
   double exp_1=0; 
   double a1_exp_1=0; 
   int index_1=0; 
   int index_2=0; 
   int index_3=0; 
   int index_4=0; 
   int run_index_1=0; 
   int run_index_2=0; 
   int run_index_3=0; 
   int cond=0; 
   int cond_1_min_1=0; 
   int cond_2=0; 
   int cond_3=0; 
   int cond_4=0; 
   int cond_5=0; 
   int cond_6=0; 
   double v1_0=0; 
   double a1_v1_0=0; 
   double v1_1=0; 
   double a1_v1_1=0; 
   double v1_2=0; 
   double a1_v1_2=0; 
   double v1_3=0; 
   double a1_v1_3=0; 
   double v1_4=0; 
   double a1_v1_4=0; 
   double v1_5=0; 
   double a1_v1_5=0; 
   double v1_6=0; 
   double a1_v1_6=0; 
   double v1_7=0; 
   double a1_v1_7=0; 
   double v1_8=0; 
   double a1_v1_8=0; 
   double v1_9=0; 
   double a1_v1_9=0; 
   double v1_10=0; 
   double a1_v1_10=0; 
   double v1_11=0; 
   double a1_v1_11=0; 
   double v1_12=0; 
   double a1_v1_12=0; 
   double v1_13=0; 
   double a1_v1_13=0; 
   double v1_14=0; 
   double a1_v1_14=0; 
   double v1_15=0; 
   double a1_v1_15=0; 
   double v1_16=0; 
   double a1_v1_16=0; 
   double v1_17=0; 
   double a1_v1_17=0; 
   double v1_18=0; 
   double a1_v1_18=0; 
   double v1_19=0; 
   double a1_v1_19=0; 
   double v1_20=0; 
   double a1_v1_20=0; 
   double v1_21=0; 
   double a1_v1_21=0; 
   double v1_22=0; 
   double a1_v1_22=0; 
   double v1_23=0; 
   double a1_v1_23=0; 
   double v1_24=0; 
   double a1_v1_24=0; 
   double v1_25=0; 
   double a1_v1_25=0; 
   double v1_26=0; 
   double a1_v1_26=0; 
   double v1_27=0; 
   double a1_v1_27=0; 
   double v1_28=0; 
   double a1_v1_28=0; 
   double v1_29=0; 
   double a1_v1_29=0; 
   double v1_30=0; 
   double a1_v1_30=0; 
   double v1_31=0; 
   double a1_v1_31=0; 
   double v1_32=0; 
   double a1_v1_32=0; 
   double v1_33=0; 
   double a1_v1_33=0; 
   double v1_34=0; 
   double a1_v1_34=0; 
   double v1_35=0; 
   double a1_v1_35=0; 
   double v1_36=0; 
   double a1_v1_36=0; 
   double v1_37=0; 
   double a1_v1_37=0; 
   double v1_38=0; 
   double a1_v1_38=0; 
   double v1_39=0; 
   double a1_v1_39=0; 
   double v1_40=0; 
   double a1_v1_40=0; 
   double v1_41=0; 
   double a1_v1_41=0; 
   double v1_42=0; 
   double a1_v1_42=0; 
   double v1_43=0; 
   double a1_v1_43=0; 
   int save_cs_c=0;
   save_cs_c=cs_c;
   if (bmode_1==1) {
      // augmented forward section
      cs[cs_c]=0; cs_c=cs_c+1;
      fds[fds_c]=f[0]; fds_c=fds_c+1; f[0]=x[0]-x[5];
      fds[fds_c]=f[1]; fds_c=fds_c+1; f[1]=x[1]-285.0;
      fds[fds_c]=f[2]; fds_c=fds_c+1; f[2]=x[2]-x[9];
      fds[fds_c]=f[3]; fds_c=fds_c+1; f[3]=x[3]-x[16+n_T];
      fds[fds_c]=f[4]; fds_c=fds_c+1; f[4]=x[4]-x[1];
      fds[fds_c]=f[5]; fds_c=fds_c+1; f[5]=x[5]-x[16+n_T+2*n_Theta-1];
      fds[fds_c]=exp_1; fds_c=fds_c+1; exp_1=u[32];
      fds[fds_c]=f[6]; fds_c=fds_c+1; f[6]=x[6]-u[29]/(pow(x[12],exp_1)+u[30])-u[31];
      fds[fds_c]=f[7]; fds_c=fds_c+1; f[7]=x[7]-x[16+n_T+2*n_Theta];
      fds[fds_c]=f[8]; fds_c=fds_c+1; f[8]=x[8]-x[3];
      fds[fds_c]=f[9]; fds_c=fds_c+1; f[9]=x[9]-x[16+n_T+2*n_Theta+3*n_Tau-1];
      fds[fds_c]=f[10]; fds_c=fds_c+1; f[10]=x[10]-(u[12]-u[13])/u[11];
      fds[fds_c]=f[11]; fds_c=fds_c+1; f[11]=x[11]-u[23]*x[12]/100.0;
      fds[fds_c]=f[12]; fds_c=fds_c+1; f[12]=x[12]-u[25];
      fds[fds_c]=f[13]; fds_c=fds_c+1; f[13]=x[13]-u[8]/(n_T-1);
      fds[fds_c]=f[14]; fds_c=fds_c+1; f[14]=x[14]-u[9]/(n_Theta-1);
      fds[fds_c]=f[15]; fds_c=fds_c+1; f[15]=x[15]-u[10]/(n_Tau-1);
      ids[ids_c]=cond; ids_c=ids_c+1; cond=16+n_T-1;
      for ( i=17; i<cond; i++) {
         cs[cs_c]=1; cs_c=cs_c+1;
         fds[fds_c]=f[i]; fds_c=fds_c+1; f[i]=u[1]/(u[2]*u[3])*(x[i+1]-2.0*x[i]+x[i-1])/pow(x[13],2)-x[10]*(x[i]-x[i-1])/(x[13])-4.0*u[4]/(u[7]*u[2]*u[3])*(x[i]-u[0]);
         ids[ids_c]=i; ids_c=ids_c+1;       }
      cs[cs_c]=2; cs_c=cs_c+1;
      fds[fds_c]=f[16]; fds_c=fds_c+1; f[16]=x[16]-x[0];
      fds[fds_c]=f[16+n_T-1]; fds_c=fds_c+1; f[16+n_T-1]=u[1]*(x[16+n_T-1]-x[16+n_T-2])/x[13]-u[2]*u[3]*u[13]/u[11]*(x[1]-x[16+n_T-1])+u[6]*(x[16+n_T-1]-u[0]);
      ids[ids_c]=cond_2; ids_c=ids_c+1; cond_2=16+n_T+n_Theta-1;
      for ( i=16+n_T+1; i<cond_2; i++) {
         cs[cs_c]=3; cs_c=cs_c+1;
         fds[fds_c]=f[i]; fds_c=fds_c+1; f[i]=u[14]*(x[i+1]-x[i])/(x[14])-2.0*u[15]*u[18]/(u[2]*u[3]*(pow(u[16],2.0)-pow(u[18],2.0)))*(x[i]-x[n_Theta+i]);
         ids[ids_c]=i; ids_c=ids_c+1;       }
      cs[cs_c]=4; cs_c=cs_c+1;
      fds[fds_c]=f[16+n_T]; fds_c=fds_c+1; f[16+n_T]=u[14]*(x[16+n_T+1]-x[16+n_T])/x[14]-2.0*u[15]*u[18]/(u[2]*u[3]*(pow(u[16],2.0)-pow(u[18],2.0)))*(x[16+n_T]-x[16+n_T+n_Theta]);
      fds[fds_c]=f[16+n_T+n_Theta-1]; fds_c=fds_c+1; f[16+n_T+n_Theta-1]=x[16+n_T+n_Theta-1]-x[2];
      ids[ids_c]=cond_3; ids_c=ids_c+1; cond_3=16+n_T+2*n_Theta-1;
      for ( i=16+n_T+n_Theta+1; i<cond_3; i++) {
         cs[cs_c]=5; cs_c=cs_c+1;
         fds[fds_c]=f[i]; fds_c=fds_c+1; f[i]=0-u[12]*(x[i]-x[i-1])/(x[14])+2.0*u[15]/(u[2]*u[3]*u[17])*(x[i-n_Theta]-x[i]);
         ids[ids_c]=i; ids_c=ids_c+1;       }
      cs[cs_c]=6; cs_c=cs_c+1;
      fds[fds_c]=f[16+n_T+2*n_Theta-1]; fds_c=fds_c+1; f[16+n_T+2*n_Theta-1]=0-u[12]*(x[16+n_T+2*n_Theta-1]-x[16+n_T+2*n_Theta-2])/x[14]+2.0*u[15]/(u[2]*u[3]*u[17])*(x[16+n_T+n_Theta-1]-x[16+n_T+2*n_Theta-1]);
      fds[fds_c]=f[16+n_T+n_Theta]; fds_c=fds_c+1; f[16+n_T+n_Theta]=x[16+n_T+n_Theta]-x[4];
      ids[ids_c]=cond_4; ids_c=ids_c+1; cond_4=16+n_T+2*n_Theta+n_Tau-1;
      for ( i=16+n_T+2*n_Theta+1; i<cond_4; i++) {
         cs[cs_c]=7; cs_c=cs_c+1;
         fds[fds_c]=f[i]; fds_c=fds_c+1; f[i]=x[11]*(x[i+1]-x[i])/(x[15])-u[19]*(x[i]-x[n_Tau+i]);
         ids[ids_c]=i; ids_c=ids_c+1;       }
      cs[cs_c]=8; cs_c=cs_c+1;
      fds[fds_c]=f[16+n_T+2*n_Theta]; fds_c=fds_c+1; f[16+n_T+2*n_Theta]=x[11]*(x[16+n_T+2*n_Theta+1]-x[16+n_T+2*n_Theta])/x[15]-u[19]*(x[16+n_T+2*n_Theta]-x[16+n_T+2*n_Theta+n_Tau]);
      fds[fds_c]=f[16+n_T+2*n_Theta+n_Tau-1]; fds_c=fds_c+1; f[16+n_T+2*n_Theta+n_Tau-1]=x[16+n_T+2*n_Theta+n_Tau-1]-x[6];
      ids[ids_c]=cond_5; ids_c=ids_c+1; cond_5=16+n_T+2*n_Theta+2*n_Tau;
      for ( i=16+n_T+2*n_Theta+n_Tau; i<cond_5; i++) {
         cs[cs_c]=9; cs_c=cs_c+1;
         fds[fds_c]=f[i]; fds_c=fds_c+1; f[i]=u[19]/u[21]*(x[i-n_Tau]-x[i])-u[20]/u[22]*(x[i]-x[i+n_Tau]);
         ids[ids_c]=i; ids_c=ids_c+1;       }
      cs[cs_c]=10; cs_c=cs_c+1;
      ids[ids_c]=cond_6; ids_c=ids_c+1; cond_6=16+n_T+2*n_Theta+3*n_Tau-1;
      for ( i=16+n_T+2*n_Theta+2*n_Tau+1; i<cond_6; i++) {
         cs[cs_c]=11; cs_c=cs_c+1;
         fds[fds_c]=f[i]; fds_c=fds_c+1; f[i]=0-u[14]*(x[i]-x[i-1])/(x[15])+u[20]*(x[i-n_Tau]-x[i]);
         ids[ids_c]=i; ids_c=ids_c+1;       }
      cs[cs_c]=12; cs_c=cs_c+1;
      fds[fds_c]=f[16+n_T+2*n_Theta+3*n_Tau-1]; fds_c=fds_c+1; f[16+n_T+2*n_Theta+3*n_Tau-1]=0-u[14]*(x[16+n_T+2*n_Theta+3*n_Tau-1]-x[16+n_T+2*n_Theta+3*n_Tau-2])/x[15]+u[20]*(x[16+n_T+2*n_Theta+2*n_Tau-1]-x[16+n_T+2*n_Theta+3*n_Tau-1]);
      fds[fds_c]=f[16+n_T+2*n_Theta+2*n_Tau]; fds_c=fds_c+1; f[16+n_T+2*n_Theta+2*n_Tau]=x[16+n_T+2*n_Theta+2*n_Tau]-x[8];
      // reverse section
      while (cs_c>save_cs_c) {
        cs_c=cs_c-1;
        if (cs[cs_c]==0) {
          // incomplete SAC
          ids_c=ids_c-1; cond=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[15]=fds[fds_c];
          v1_0=x[15];
          v1_1=u[10];
          v1_2=n_Tau;
          v1_3=1;
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1/v1_5;
          v1_7=v1_0-v1_6;
          // adjoint assignment
          a1_v1_7=a1_f[15]; a1_f[15]=0;
          a1_v1_0=a1_v1_7; a1_v1_6=0-a1_v1_7;
          a1_v1_1=1/v1_5*a1_v1_6; a1_v1_5=0-v1_1/(v1_5*v1_5)*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
                    a1_u[10]=a1_u[10]+a1_v1_1;
          a1_x[15]=a1_x[15]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[14]=fds[fds_c];
          v1_0=x[14];
          v1_1=u[9];
          v1_2=n_Theta;
          v1_3=1;
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1/v1_5;
          v1_7=v1_0-v1_6;
          // adjoint assignment
          a1_v1_7=a1_f[14]; a1_f[14]=0;
          a1_v1_0=a1_v1_7; a1_v1_6=0-a1_v1_7;
          a1_v1_1=1/v1_5*a1_v1_6; a1_v1_5=0-v1_1/(v1_5*v1_5)*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
                    a1_u[9]=a1_u[9]+a1_v1_1;
          a1_x[14]=a1_x[14]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[13]=fds[fds_c];
          v1_0=x[13];
          v1_1=u[8];
          v1_2=n_T;
          v1_3=1;
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1/v1_5;
          v1_7=v1_0-v1_6;
          // adjoint assignment
          a1_v1_7=a1_f[13]; a1_f[13]=0;
          a1_v1_0=a1_v1_7; a1_v1_6=0-a1_v1_7;
          a1_v1_1=1/v1_5*a1_v1_6; a1_v1_5=0-v1_1/(v1_5*v1_5)*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
                    a1_u[8]=a1_u[8]+a1_v1_1;
          a1_x[13]=a1_x[13]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[12]=fds[fds_c];
          v1_0=x[12];
          v1_1=u[25];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[12]; a1_f[12]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_u[25]=a1_u[25]+a1_v1_1;
          a1_x[12]=a1_x[12]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[11]=fds[fds_c];
          v1_0=x[11];
          v1_1=u[23];
          v1_2=x[12];
          v1_3=v1_1*v1_2;
          v1_4=100.0;
          v1_5=v1_3/v1_4;
          v1_6=v1_0-v1_5;
          // adjoint assignment
          a1_v1_6=a1_f[11]; a1_f[11]=0;
          a1_v1_0=a1_v1_6; a1_v1_5=0-a1_v1_6;
          a1_v1_3=1/v1_4*a1_v1_5; a1_v1_4=0-v1_3/(v1_4*v1_4)*a1_v1_5;
          a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
          a1_x[12]=a1_x[12]+a1_v1_2;
          a1_u[23]=a1_u[23]+a1_v1_1;
          a1_x[11]=a1_x[11]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[10]=fds[fds_c];
          v1_0=x[10];
          v1_1=u[12];
          v1_2=u[13];
          v1_3=v1_1-v1_2;
          v1_4=v1_3;
          v1_5=u[11];
          v1_6=v1_4/v1_5;
          v1_7=v1_0-v1_6;
          // adjoint assignment
          a1_v1_7=a1_f[10]; a1_f[10]=0;
          a1_v1_0=a1_v1_7; a1_v1_6=0-a1_v1_7;
          a1_v1_4=1/v1_5*a1_v1_6; a1_v1_5=0-v1_4/(v1_5*v1_5)*a1_v1_6;
          a1_u[11]=a1_u[11]+a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_u[13]=a1_u[13]+a1_v1_2;
          a1_u[12]=a1_u[12]+a1_v1_1;
          a1_x[10]=a1_x[10]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[9]=fds[fds_c];
          v1_0=x[9];
          v1_1=x[16+n_T+2*n_Theta+3*n_Tau-1];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[9]; a1_f[9]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[16+n_T+2*n_Theta+3*n_Tau-1]=a1_x[16+n_T+2*n_Theta+3*n_Tau-1]+a1_v1_1;
          a1_x[9]=a1_x[9]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[8]=fds[fds_c];
          v1_0=x[8];
          v1_1=x[3];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[8]; a1_f[8]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[3]=a1_x[3]+a1_v1_1;
          a1_x[8]=a1_x[8]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[7]=fds[fds_c];
          v1_0=x[7];
          v1_1=x[16+n_T+2*n_Theta];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[7]; a1_f[7]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[16+n_T+2*n_Theta]=a1_x[16+n_T+2*n_Theta]+a1_v1_1;
          a1_x[7]=a1_x[7]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[6]=fds[fds_c];
          v1_0=x[6];
          v1_1=u[29];
          v1_2=x[12];
          v1_3=pow(v1_2,exp_1);
          v1_4=u[30];
          v1_5=v1_3+v1_4;
          v1_6=v1_5;
          v1_7=v1_1/v1_6;
          v1_8=v1_0-v1_7;
          v1_9=u[31];
          v1_10=v1_8-v1_9;
          // adjoint assignment
          a1_v1_10=a1_f[6]; a1_f[6]=0;
          a1_v1_8=a1_v1_10; a1_v1_9=0-a1_v1_10;
          a1_u[31]=a1_u[31]+a1_v1_9;
          a1_v1_0=a1_v1_8; a1_v1_7=0-a1_v1_8;
          a1_v1_1=1/v1_6*a1_v1_7; a1_v1_6=0-v1_1/(v1_6*v1_6)*a1_v1_7;
          a1_v1_5=a1_v1_6;
          a1_v1_3=a1_v1_5; a1_v1_4=a1_v1_5;
          a1_u[30]=a1_u[30]+a1_v1_4;
          a1_v1_2=exp_1-1;
      a1_v1_2=exp_1*pow(v1_2,a1_v1_2)*a1_v1_3;
      a1_exp_1=a1_exp_1+v1_3*dcc_log(v1_2)*a1_v1_3;
          a1_x[12]=a1_x[12]+a1_v1_2;
          a1_u[29]=a1_u[29]+a1_v1_1;
          a1_x[6]=a1_x[6]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; exp_1=fds[fds_c];
          v1_0=u[32];
          // adjoint assignment
          a1_v1_0=a1_exp_1; a1_exp_1=0;
          a1_u[32]=a1_u[32]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[5]=fds[fds_c];
          v1_0=x[5];
          v1_1=x[16+n_T+2*n_Theta-1];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[5]; a1_f[5]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[16+n_T+2*n_Theta-1]=a1_x[16+n_T+2*n_Theta-1]+a1_v1_1;
          a1_x[5]=a1_x[5]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[4]=fds[fds_c];
          v1_0=x[4];
          v1_1=x[1];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[4]; a1_f[4]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[1]=a1_x[1]+a1_v1_1;
          a1_x[4]=a1_x[4]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[3]=fds[fds_c];
          v1_0=x[3];
          v1_1=x[16+n_T];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[3]; a1_f[3]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[16+n_T]=a1_x[16+n_T]+a1_v1_1;
          a1_x[3]=a1_x[3]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[2]=fds[fds_c];
          v1_0=x[2];
          v1_1=x[9];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[2]; a1_f[2]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[9]=a1_x[9]+a1_v1_1;
          a1_x[2]=a1_x[2]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[1]=fds[fds_c];
          v1_0=x[1];
          v1_1=285.0;
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[1]; a1_f[1]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[1]=a1_x[1]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[0]=fds[fds_c];
          v1_0=x[0];
          v1_1=x[5];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[0]; a1_f[0]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[5]=a1_x[5]+a1_v1_1;
          a1_x[0]=a1_x[0]+a1_v1_0;
        }
        if (cs[cs_c]==1) {
          ids_c=ids_c-1; i=ids[ids_c];
i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[i]=fds[fds_c];
          v1_0=u[1];
          v1_1=u[2];
          v1_2=u[3];
          v1_3=v1_1*v1_2;
          v1_4=v1_3;
          v1_5=v1_0/v1_4;
          v1_6=x[i+1];
          v1_7=2.0;
          v1_8=x[i];
          v1_9=v1_7*v1_8;
          v1_10=v1_6-v1_9;
          v1_11=x[i-1];
          v1_12=v1_10+v1_11;
          v1_13=v1_12;
          v1_14=v1_5*v1_13;
          v1_15=x[13];
          v1_16=pow(v1_15,2);
          v1_17=v1_14/v1_16;
          v1_18=x[10];
          v1_19=x[i];
          v1_20=x[i-1];
          v1_21=v1_19-v1_20;
          v1_22=v1_21;
          v1_23=v1_18*v1_22;
          v1_24=x[13];
          v1_25=v1_24;
          v1_26=v1_23/v1_25;
          v1_27=v1_17-v1_26;
          v1_28=4.0;
          v1_29=u[4];
          v1_30=v1_28*v1_29;
          v1_31=u[7];
          v1_32=u[2];
          v1_33=v1_31*v1_32;
          v1_34=u[3];
          v1_35=v1_33*v1_34;
          v1_36=v1_35;
          v1_37=v1_30/v1_36;
          v1_38=x[i];
          v1_39=u[0];
          v1_40=v1_38-v1_39;
          v1_41=v1_40;
          v1_42=v1_37*v1_41;
          v1_43=v1_27-v1_42;
          // adjoint assignment
          a1_v1_43=a1_f[i]; a1_f[i]=0;
          a1_v1_27=a1_v1_43; a1_v1_42=0-a1_v1_43;
          a1_v1_37=v1_41*a1_v1_42; a1_v1_41=v1_37*a1_v1_42;
          a1_v1_40=a1_v1_41;
          a1_v1_38=a1_v1_40; a1_v1_39=0-a1_v1_40;
          a1_u[0]=a1_u[0]+a1_v1_39;
          a1_x[i]=a1_x[i]+a1_v1_38;
          a1_v1_30=1/v1_36*a1_v1_37; a1_v1_36=0-v1_30/(v1_36*v1_36)*a1_v1_37;
          a1_v1_35=a1_v1_36;
          a1_v1_33=v1_34*a1_v1_35; a1_v1_34=v1_33*a1_v1_35;
          a1_u[3]=a1_u[3]+a1_v1_34;
          a1_v1_31=v1_32*a1_v1_33; a1_v1_32=v1_31*a1_v1_33;
          a1_u[2]=a1_u[2]+a1_v1_32;
          a1_u[7]=a1_u[7]+a1_v1_31;
          a1_v1_28=v1_29*a1_v1_30; a1_v1_29=v1_28*a1_v1_30;
          a1_u[4]=a1_u[4]+a1_v1_29;
          a1_v1_17=a1_v1_27; a1_v1_26=0-a1_v1_27;
          a1_v1_23=1/v1_25*a1_v1_26; a1_v1_25=0-v1_23/(v1_25*v1_25)*a1_v1_26;
          a1_v1_24=a1_v1_25;
          a1_x[13]=a1_x[13]+a1_v1_24;
          a1_v1_18=v1_22*a1_v1_23; a1_v1_22=v1_18*a1_v1_23;
          a1_v1_21=a1_v1_22;
          a1_v1_19=a1_v1_21; a1_v1_20=0-a1_v1_21;
          a1_x[i-1]=a1_x[i-1]+a1_v1_20;
          a1_x[i]=a1_x[i]+a1_v1_19;
          a1_x[10]=a1_x[10]+a1_v1_18;
          a1_v1_14=1/v1_16*a1_v1_17; a1_v1_16=0-v1_14/(v1_16*v1_16)*a1_v1_17;
          a1_v1_15=2-1;
         a1_v1_15=2*pow(v1_15,a1_v1_15)*a1_v1_16;
          a1_x[13]=a1_x[13]+a1_v1_15;
          a1_v1_5=v1_13*a1_v1_14; a1_v1_13=v1_5*a1_v1_14;
          a1_v1_12=a1_v1_13;
          a1_v1_10=a1_v1_12; a1_v1_11=a1_v1_12;
          a1_x[i-1]=a1_x[i-1]+a1_v1_11;
          a1_v1_6=a1_v1_10; a1_v1_9=0-a1_v1_10;
          a1_v1_7=v1_8*a1_v1_9; a1_v1_8=v1_7*a1_v1_9;
          a1_x[i]=a1_x[i]+a1_v1_8;
          a1_x[i+1]=a1_x[i+1]+a1_v1_6;
          a1_v1_0=1/v1_4*a1_v1_5; a1_v1_4=0-v1_0/(v1_4*v1_4)*a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
          a1_u[3]=a1_u[3]+a1_v1_2;
          a1_u[2]=a1_u[2]+a1_v1_1;
          a1_u[1]=a1_u[1]+a1_v1_0;
        }
        if (cs[cs_c]==2) {
          // incomplete SAC
          ids_c=ids_c-1; cond_2=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T-1]=fds[fds_c];
          v1_0=u[1];
          v1_1=x[16+n_T-1];
          v1_2=x[16+n_T-2];
          v1_3=v1_1-v1_2;
          v1_4=v1_3;
          v1_5=v1_0*v1_4;
          v1_6=x[13];
          v1_7=v1_5/v1_6;
          v1_8=u[2];
          v1_9=u[3];
          v1_10=v1_8*v1_9;
          v1_11=u[13];
          v1_12=v1_10*v1_11;
          v1_13=u[11];
          v1_14=v1_12/v1_13;
          v1_15=x[1];
          v1_16=x[16+n_T-1];
          v1_17=v1_15-v1_16;
          v1_18=v1_17;
          v1_19=v1_14*v1_18;
          v1_20=v1_7-v1_19;
          v1_21=u[6];
          v1_22=x[16+n_T-1];
          v1_23=u[0];
          v1_24=v1_22-v1_23;
          v1_25=v1_24;
          v1_26=v1_21*v1_25;
          v1_27=v1_20+v1_26;
          // adjoint assignment
          a1_v1_27=a1_f[16+n_T-1]; a1_f[16+n_T-1]=0;
          a1_v1_20=a1_v1_27; a1_v1_26=a1_v1_27;
          a1_v1_21=v1_25*a1_v1_26; a1_v1_25=v1_21*a1_v1_26;
          a1_v1_24=a1_v1_25;
          a1_v1_22=a1_v1_24; a1_v1_23=0-a1_v1_24;
          a1_u[0]=a1_u[0]+a1_v1_23;
          a1_x[16+n_T-1]=a1_x[16+n_T-1]+a1_v1_22;
          a1_u[6]=a1_u[6]+a1_v1_21;
          a1_v1_7=a1_v1_20; a1_v1_19=0-a1_v1_20;
          a1_v1_14=v1_18*a1_v1_19; a1_v1_18=v1_14*a1_v1_19;
          a1_v1_17=a1_v1_18;
          a1_v1_15=a1_v1_17; a1_v1_16=0-a1_v1_17;
          a1_x[16+n_T-1]=a1_x[16+n_T-1]+a1_v1_16;
          a1_x[1]=a1_x[1]+a1_v1_15;
          a1_v1_12=1/v1_13*a1_v1_14; a1_v1_13=0-v1_12/(v1_13*v1_13)*a1_v1_14;
          a1_u[11]=a1_u[11]+a1_v1_13;
          a1_v1_10=v1_11*a1_v1_12; a1_v1_11=v1_10*a1_v1_12;
          a1_u[13]=a1_u[13]+a1_v1_11;
          a1_v1_8=v1_9*a1_v1_10; a1_v1_9=v1_8*a1_v1_10;
          a1_u[3]=a1_u[3]+a1_v1_9;
          a1_u[2]=a1_u[2]+a1_v1_8;
          a1_v1_5=1/v1_6*a1_v1_7; a1_v1_6=0-v1_5/(v1_6*v1_6)*a1_v1_7;
          a1_x[13]=a1_x[13]+a1_v1_6;
          a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_x[16+n_T-2]=a1_x[16+n_T-2]+a1_v1_2;
          a1_x[16+n_T-1]=a1_x[16+n_T-1]+a1_v1_1;
          a1_u[1]=a1_u[1]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[16]=fds[fds_c];
          v1_0=x[16];
          v1_1=x[0];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[16]; a1_f[16]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[0]=a1_x[0]+a1_v1_1;
          a1_x[16]=a1_x[16]+a1_v1_0;
        }
        if (cs[cs_c]==3) {
          ids_c=ids_c-1; i=ids[ids_c];
i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[i]=fds[fds_c];
          v1_0=u[14];
          v1_1=x[i+1];
          v1_2=x[i];
          v1_3=v1_1-v1_2;
          v1_4=v1_3;
          v1_5=v1_0*v1_4;
          v1_6=x[14];
          v1_7=v1_6;
          v1_8=v1_5/v1_7;
          v1_9=2.0;
          v1_10=u[15];
          v1_11=v1_9*v1_10;
          v1_12=u[18];
          v1_13=v1_11*v1_12;
          v1_14=u[2];
          v1_15=u[3];
          v1_16=v1_14*v1_15;
          v1_17=u[16];
          v1_18=pow(v1_17,2.0);
          v1_19=u[18];
          v1_20=pow(v1_19,2.0);
          v1_21=v1_18-v1_20;
          v1_22=v1_21;
          v1_23=v1_16*v1_22;
          v1_24=v1_23;
          v1_25=v1_13/v1_24;
          v1_26=x[i];
          v1_27=x[n_Theta+i];
          v1_28=v1_26-v1_27;
          v1_29=v1_28;
          v1_30=v1_25*v1_29;
          v1_31=v1_8-v1_30;
          // adjoint assignment
          a1_v1_31=a1_f[i]; a1_f[i]=0;
          a1_v1_8=a1_v1_31; a1_v1_30=0-a1_v1_31;
          a1_v1_25=v1_29*a1_v1_30; a1_v1_29=v1_25*a1_v1_30;
          a1_v1_28=a1_v1_29;
          a1_v1_26=a1_v1_28; a1_v1_27=0-a1_v1_28;
          a1_x[n_Theta+i]=a1_x[n_Theta+i]+a1_v1_27;
          a1_x[i]=a1_x[i]+a1_v1_26;
          a1_v1_13=1/v1_24*a1_v1_25; a1_v1_24=0-v1_13/(v1_24*v1_24)*a1_v1_25;
          a1_v1_23=a1_v1_24;
          a1_v1_16=v1_22*a1_v1_23; a1_v1_22=v1_16*a1_v1_23;
          a1_v1_21=a1_v1_22;
          a1_v1_18=a1_v1_21; a1_v1_20=0-a1_v1_21;
          a1_v1_19=2.0-1;
         a1_v1_19=2.0*pow(v1_19,a1_v1_19)*a1_v1_20;
          a1_u[18]=a1_u[18]+a1_v1_19;
          a1_v1_17=2.0-1;
         a1_v1_17=2.0*pow(v1_17,a1_v1_17)*a1_v1_18;
          a1_u[16]=a1_u[16]+a1_v1_17;
          a1_v1_14=v1_15*a1_v1_16; a1_v1_15=v1_14*a1_v1_16;
          a1_u[3]=a1_u[3]+a1_v1_15;
          a1_u[2]=a1_u[2]+a1_v1_14;
          a1_v1_11=v1_12*a1_v1_13; a1_v1_12=v1_11*a1_v1_13;
          a1_u[18]=a1_u[18]+a1_v1_12;
          a1_v1_9=v1_10*a1_v1_11; a1_v1_10=v1_9*a1_v1_11;
          a1_u[15]=a1_u[15]+a1_v1_10;
          a1_v1_5=1/v1_7*a1_v1_8; a1_v1_7=0-v1_5/(v1_7*v1_7)*a1_v1_8;
          a1_v1_6=a1_v1_7;
          a1_x[14]=a1_x[14]+a1_v1_6;
          a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_x[i]=a1_x[i]+a1_v1_2;
          a1_x[i+1]=a1_x[i+1]+a1_v1_1;
          a1_u[14]=a1_u[14]+a1_v1_0;
        }
        if (cs[cs_c]==4) {
          // incomplete SAC
          ids_c=ids_c-1; cond_3=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+n_Theta-1]=fds[fds_c];
          v1_0=x[16+n_T+n_Theta-1];
          v1_1=x[2];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[16+n_T+n_Theta-1]; a1_f[16+n_T+n_Theta-1]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[2]=a1_x[2]+a1_v1_1;
          a1_x[16+n_T+n_Theta-1]=a1_x[16+n_T+n_Theta-1]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T]=fds[fds_c];
          v1_0=u[14];
          v1_1=x[16+n_T+1];
          v1_2=x[16+n_T];
          v1_3=v1_1-v1_2;
          v1_4=v1_3;
          v1_5=v1_0*v1_4;
          v1_6=x[14];
          v1_7=v1_5/v1_6;
          v1_8=2.0;
          v1_9=u[15];
          v1_10=v1_8*v1_9;
          v1_11=u[18];
          v1_12=v1_10*v1_11;
          v1_13=u[2];
          v1_14=u[3];
          v1_15=v1_13*v1_14;
          v1_16=u[16];
          v1_17=pow(v1_16,2.0);
          v1_18=u[18];
          v1_19=pow(v1_18,2.0);
          v1_20=v1_17-v1_19;
          v1_21=v1_20;
          v1_22=v1_15*v1_21;
          v1_23=v1_22;
          v1_24=v1_12/v1_23;
          v1_25=x[16+n_T];
          v1_26=x[16+n_T+n_Theta];
          v1_27=v1_25-v1_26;
          v1_28=v1_27;
          v1_29=v1_24*v1_28;
          v1_30=v1_7-v1_29;
          // adjoint assignment
          a1_v1_30=a1_f[16+n_T]; a1_f[16+n_T]=0;
          a1_v1_7=a1_v1_30; a1_v1_29=0-a1_v1_30;
          a1_v1_24=v1_28*a1_v1_29; a1_v1_28=v1_24*a1_v1_29;
          a1_v1_27=a1_v1_28;
          a1_v1_25=a1_v1_27; a1_v1_26=0-a1_v1_27;
          a1_x[16+n_T+n_Theta]=a1_x[16+n_T+n_Theta]+a1_v1_26;
          a1_x[16+n_T]=a1_x[16+n_T]+a1_v1_25;
          a1_v1_12=1/v1_23*a1_v1_24; a1_v1_23=0-v1_12/(v1_23*v1_23)*a1_v1_24;
          a1_v1_22=a1_v1_23;
          a1_v1_15=v1_21*a1_v1_22; a1_v1_21=v1_15*a1_v1_22;
          a1_v1_20=a1_v1_21;
          a1_v1_17=a1_v1_20; a1_v1_19=0-a1_v1_20;
          a1_v1_18=2.0-1;
      a1_v1_18=2.0*pow(v1_18,a1_v1_18)*a1_v1_19;
          a1_u[18]=a1_u[18]+a1_v1_18;
          a1_v1_16=2.0-1;
      a1_v1_16=2.0*pow(v1_16,a1_v1_16)*a1_v1_17;
          a1_u[16]=a1_u[16]+a1_v1_16;
          a1_v1_13=v1_14*a1_v1_15; a1_v1_14=v1_13*a1_v1_15;
          a1_u[3]=a1_u[3]+a1_v1_14;
          a1_u[2]=a1_u[2]+a1_v1_13;
          a1_v1_10=v1_11*a1_v1_12; a1_v1_11=v1_10*a1_v1_12;
          a1_u[18]=a1_u[18]+a1_v1_11;
          a1_v1_8=v1_9*a1_v1_10; a1_v1_9=v1_8*a1_v1_10;
          a1_u[15]=a1_u[15]+a1_v1_9;
          a1_v1_5=1/v1_6*a1_v1_7; a1_v1_6=0-v1_5/(v1_6*v1_6)*a1_v1_7;
          a1_x[14]=a1_x[14]+a1_v1_6;
          a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_x[16+n_T]=a1_x[16+n_T]+a1_v1_2;
          a1_x[16+n_T+1]=a1_x[16+n_T+1]+a1_v1_1;
          a1_u[14]=a1_u[14]+a1_v1_0;
        }
        if (cs[cs_c]==5) {
          ids_c=ids_c-1; i=ids[ids_c];
i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[i]=fds[fds_c];
          v1_0=0;
          v1_1=u[12];
          v1_2=x[i];
          v1_3=x[i-1];
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1*v1_5;
          v1_7=x[14];
          v1_8=v1_7;
          v1_9=v1_6/v1_8;
          v1_10=v1_0-v1_9;
          v1_11=2.0;
          v1_12=u[15];
          v1_13=v1_11*v1_12;
          v1_14=u[2];
          v1_15=u[3];
          v1_16=v1_14*v1_15;
          v1_17=u[17];
          v1_18=v1_16*v1_17;
          v1_19=v1_18;
          v1_20=v1_13/v1_19;
          v1_21=x[i-n_Theta];
          v1_22=x[i];
          v1_23=v1_21-v1_22;
          v1_24=v1_23;
          v1_25=v1_20*v1_24;
          v1_26=v1_10+v1_25;
          // adjoint assignment
          a1_v1_26=a1_f[i]; a1_f[i]=0;
          a1_v1_10=a1_v1_26; a1_v1_25=a1_v1_26;
          a1_v1_20=v1_24*a1_v1_25; a1_v1_24=v1_20*a1_v1_25;
          a1_v1_23=a1_v1_24;
          a1_v1_21=a1_v1_23; a1_v1_22=0-a1_v1_23;
          a1_x[i]=a1_x[i]+a1_v1_22;
          a1_x[i-n_Theta]=a1_x[i-n_Theta]+a1_v1_21;
          a1_v1_13=1/v1_19*a1_v1_20; a1_v1_19=0-v1_13/(v1_19*v1_19)*a1_v1_20;
          a1_v1_18=a1_v1_19;
          a1_v1_16=v1_17*a1_v1_18; a1_v1_17=v1_16*a1_v1_18;
          a1_u[17]=a1_u[17]+a1_v1_17;
          a1_v1_14=v1_15*a1_v1_16; a1_v1_15=v1_14*a1_v1_16;
          a1_u[3]=a1_u[3]+a1_v1_15;
          a1_u[2]=a1_u[2]+a1_v1_14;
          a1_v1_11=v1_12*a1_v1_13; a1_v1_12=v1_11*a1_v1_13;
          a1_u[15]=a1_u[15]+a1_v1_12;
          a1_v1_0=a1_v1_10; a1_v1_9=0-a1_v1_10;
          a1_v1_6=1/v1_8*a1_v1_9; a1_v1_8=0-v1_6/(v1_8*v1_8)*a1_v1_9;
          a1_v1_7=a1_v1_8;
          a1_x[14]=a1_x[14]+a1_v1_7;
          a1_v1_1=v1_5*a1_v1_6; a1_v1_5=v1_1*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
          a1_x[i-1]=a1_x[i-1]+a1_v1_3;
          a1_x[i]=a1_x[i]+a1_v1_2;
          a1_u[12]=a1_u[12]+a1_v1_1;
        }
        if (cs[cs_c]==6) {
          // incomplete SAC
          ids_c=ids_c-1; cond_4=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+n_Theta]=fds[fds_c];
          v1_0=x[16+n_T+n_Theta];
          v1_1=x[4];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[16+n_T+n_Theta]; a1_f[16+n_T+n_Theta]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[4]=a1_x[4]+a1_v1_1;
          a1_x[16+n_T+n_Theta]=a1_x[16+n_T+n_Theta]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+2*n_Theta-1]=fds[fds_c];
          v1_0=0;
          v1_1=u[12];
          v1_2=x[16+n_T+2*n_Theta-1];
          v1_3=x[16+n_T+2*n_Theta-2];
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1*v1_5;
          v1_7=x[14];
          v1_8=v1_6/v1_7;
          v1_9=v1_0-v1_8;
          v1_10=2.0;
          v1_11=u[15];
          v1_12=v1_10*v1_11;
          v1_13=u[2];
          v1_14=u[3];
          v1_15=v1_13*v1_14;
          v1_16=u[17];
          v1_17=v1_15*v1_16;
          v1_18=v1_17;
          v1_19=v1_12/v1_18;
          v1_20=x[16+n_T+n_Theta-1];
          v1_21=x[16+n_T+2*n_Theta-1];
          v1_22=v1_20-v1_21;
          v1_23=v1_22;
          v1_24=v1_19*v1_23;
          v1_25=v1_9+v1_24;
          // adjoint assignment
          a1_v1_25=a1_f[16+n_T+2*n_Theta-1]; a1_f[16+n_T+2*n_Theta-1]=0;
          a1_v1_9=a1_v1_25; a1_v1_24=a1_v1_25;
          a1_v1_19=v1_23*a1_v1_24; a1_v1_23=v1_19*a1_v1_24;
          a1_v1_22=a1_v1_23;
          a1_v1_20=a1_v1_22; a1_v1_21=0-a1_v1_22;
          a1_x[16+n_T+2*n_Theta-1]=a1_x[16+n_T+2*n_Theta-1]+a1_v1_21;
          a1_x[16+n_T+n_Theta-1]=a1_x[16+n_T+n_Theta-1]+a1_v1_20;
          a1_v1_12=1/v1_18*a1_v1_19; a1_v1_18=0-v1_12/(v1_18*v1_18)*a1_v1_19;
          a1_v1_17=a1_v1_18;
          a1_v1_15=v1_16*a1_v1_17; a1_v1_16=v1_15*a1_v1_17;
          a1_u[17]=a1_u[17]+a1_v1_16;
          a1_v1_13=v1_14*a1_v1_15; a1_v1_14=v1_13*a1_v1_15;
          a1_u[3]=a1_u[3]+a1_v1_14;
          a1_u[2]=a1_u[2]+a1_v1_13;
          a1_v1_10=v1_11*a1_v1_12; a1_v1_11=v1_10*a1_v1_12;
          a1_u[15]=a1_u[15]+a1_v1_11;
          a1_v1_0=a1_v1_9; a1_v1_8=0-a1_v1_9;
          a1_v1_6=1/v1_7*a1_v1_8; a1_v1_7=0-v1_6/(v1_7*v1_7)*a1_v1_8;
          a1_x[14]=a1_x[14]+a1_v1_7;
          a1_v1_1=v1_5*a1_v1_6; a1_v1_5=v1_1*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
          a1_x[16+n_T+2*n_Theta-2]=a1_x[16+n_T+2*n_Theta-2]+a1_v1_3;
          a1_x[16+n_T+2*n_Theta-1]=a1_x[16+n_T+2*n_Theta-1]+a1_v1_2;
          a1_u[12]=a1_u[12]+a1_v1_1;
        }
        if (cs[cs_c]==7) {
          ids_c=ids_c-1; i=ids[ids_c];
i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[i]=fds[fds_c];
          v1_0=x[11];
          v1_1=x[i+1];
          v1_2=x[i];
          v1_3=v1_1-v1_2;
          v1_4=v1_3;
          v1_5=v1_0*v1_4;
          v1_6=x[15];
          v1_7=v1_6;
          v1_8=v1_5/v1_7;
          v1_9=u[19];
          v1_10=x[i];
          v1_11=x[n_Tau+i];
          v1_12=v1_10-v1_11;
          v1_13=v1_12;
          v1_14=v1_9*v1_13;
          v1_15=v1_8-v1_14;
          // adjoint assignment
          a1_v1_15=a1_f[i]; a1_f[i]=0;
          a1_v1_8=a1_v1_15; a1_v1_14=0-a1_v1_15;
          a1_v1_9=v1_13*a1_v1_14; a1_v1_13=v1_9*a1_v1_14;
          a1_v1_12=a1_v1_13;
          a1_v1_10=a1_v1_12; a1_v1_11=0-a1_v1_12;
          a1_x[n_Tau+i]=a1_x[n_Tau+i]+a1_v1_11;
          a1_x[i]=a1_x[i]+a1_v1_10;
          a1_u[19]=a1_u[19]+a1_v1_9;
          a1_v1_5=1/v1_7*a1_v1_8; a1_v1_7=0-v1_5/(v1_7*v1_7)*a1_v1_8;
          a1_v1_6=a1_v1_7;
          a1_x[15]=a1_x[15]+a1_v1_6;
          a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_x[i]=a1_x[i]+a1_v1_2;
          a1_x[i+1]=a1_x[i+1]+a1_v1_1;
          a1_x[11]=a1_x[11]+a1_v1_0;
        }
        if (cs[cs_c]==8) {
          // incomplete SAC
          ids_c=ids_c-1; cond_5=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+2*n_Theta+n_Tau-1]=fds[fds_c];
          v1_0=x[16+n_T+2*n_Theta+n_Tau-1];
          v1_1=x[6];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[16+n_T+2*n_Theta+n_Tau-1]; a1_f[16+n_T+2*n_Theta+n_Tau-1]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[6]=a1_x[6]+a1_v1_1;
          a1_x[16+n_T+2*n_Theta+n_Tau-1]=a1_x[16+n_T+2*n_Theta+n_Tau-1]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+2*n_Theta]=fds[fds_c];
          v1_0=x[11];
          v1_1=x[16+n_T+2*n_Theta+1];
          v1_2=x[16+n_T+2*n_Theta];
          v1_3=v1_1-v1_2;
          v1_4=v1_3;
          v1_5=v1_0*v1_4;
          v1_6=x[15];
          v1_7=v1_5/v1_6;
          v1_8=u[19];
          v1_9=x[16+n_T+2*n_Theta];
          v1_10=x[16+n_T+2*n_Theta+n_Tau];
          v1_11=v1_9-v1_10;
          v1_12=v1_11;
          v1_13=v1_8*v1_12;
          v1_14=v1_7-v1_13;
          // adjoint assignment
          a1_v1_14=a1_f[16+n_T+2*n_Theta]; a1_f[16+n_T+2*n_Theta]=0;
          a1_v1_7=a1_v1_14; a1_v1_13=0-a1_v1_14;
          a1_v1_8=v1_12*a1_v1_13; a1_v1_12=v1_8*a1_v1_13;
          a1_v1_11=a1_v1_12;
          a1_v1_9=a1_v1_11; a1_v1_10=0-a1_v1_11;
          a1_x[16+n_T+2*n_Theta+n_Tau]=a1_x[16+n_T+2*n_Theta+n_Tau]+a1_v1_10;
          a1_x[16+n_T+2*n_Theta]=a1_x[16+n_T+2*n_Theta]+a1_v1_9;
          a1_u[19]=a1_u[19]+a1_v1_8;
          a1_v1_5=1/v1_6*a1_v1_7; a1_v1_6=0-v1_5/(v1_6*v1_6)*a1_v1_7;
          a1_x[15]=a1_x[15]+a1_v1_6;
          a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_x[16+n_T+2*n_Theta]=a1_x[16+n_T+2*n_Theta]+a1_v1_2;
          a1_x[16+n_T+2*n_Theta+1]=a1_x[16+n_T+2*n_Theta+1]+a1_v1_1;
          a1_x[11]=a1_x[11]+a1_v1_0;
        }
        if (cs[cs_c]==9) {
          ids_c=ids_c-1; i=ids[ids_c];
i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[i]=fds[fds_c];
          v1_0=u[19];
          v1_1=u[21];
          v1_2=v1_0/v1_1;
          v1_3=x[i-n_Tau];
          v1_4=x[i];
          v1_5=v1_3-v1_4;
          v1_6=v1_5;
          v1_7=v1_2*v1_6;
          v1_8=u[20];
          v1_9=u[22];
          v1_10=v1_8/v1_9;
          v1_11=x[i];
          v1_12=x[i+n_Tau];
          v1_13=v1_11-v1_12;
          v1_14=v1_13;
          v1_15=v1_10*v1_14;
          v1_16=v1_7-v1_15;
          // adjoint assignment
          a1_v1_16=a1_f[i]; a1_f[i]=0;
          a1_v1_7=a1_v1_16; a1_v1_15=0-a1_v1_16;
          a1_v1_10=v1_14*a1_v1_15; a1_v1_14=v1_10*a1_v1_15;
          a1_v1_13=a1_v1_14;
          a1_v1_11=a1_v1_13; a1_v1_12=0-a1_v1_13;
          a1_x[i+n_Tau]=a1_x[i+n_Tau]+a1_v1_12;
          a1_x[i]=a1_x[i]+a1_v1_11;
          a1_v1_8=1/v1_9*a1_v1_10; a1_v1_9=0-v1_8/(v1_9*v1_9)*a1_v1_10;
          a1_u[22]=a1_u[22]+a1_v1_9;
          a1_u[20]=a1_u[20]+a1_v1_8;
          a1_v1_2=v1_6*a1_v1_7; a1_v1_6=v1_2*a1_v1_7;
          a1_v1_5=a1_v1_6;
          a1_v1_3=a1_v1_5; a1_v1_4=0-a1_v1_5;
          a1_x[i]=a1_x[i]+a1_v1_4;
          a1_x[i-n_Tau]=a1_x[i-n_Tau]+a1_v1_3;
          a1_v1_0=1/v1_1*a1_v1_2; a1_v1_1=0-v1_0/(v1_1*v1_1)*a1_v1_2;
          a1_u[21]=a1_u[21]+a1_v1_1;
          a1_u[19]=a1_u[19]+a1_v1_0;
        }
        if (cs[cs_c]==10) {
          // incomplete SAC
          ids_c=ids_c-1; cond_6=ids[ids_c];
        }
        if (cs[cs_c]==11) {
          ids_c=ids_c-1; i=ids[ids_c];
i=ids[ids_c];
          // incomplete SAC
          fds_c=fds_c-1; f[i]=fds[fds_c];
          v1_0=0;
          v1_1=u[14];
          v1_2=x[i];
          v1_3=x[i-1];
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1*v1_5;
          v1_7=x[15];
          v1_8=v1_7;
          v1_9=v1_6/v1_8;
          v1_10=v1_0-v1_9;
          v1_11=u[20];
          v1_12=x[i-n_Tau];
          v1_13=x[i];
          v1_14=v1_12-v1_13;
          v1_15=v1_14;
          v1_16=v1_11*v1_15;
          v1_17=v1_10+v1_16;
          // adjoint assignment
          a1_v1_17=a1_f[i]; a1_f[i]=0;
          a1_v1_10=a1_v1_17; a1_v1_16=a1_v1_17;
          a1_v1_11=v1_15*a1_v1_16; a1_v1_15=v1_11*a1_v1_16;
          a1_v1_14=a1_v1_15;
          a1_v1_12=a1_v1_14; a1_v1_13=0-a1_v1_14;
          a1_x[i]=a1_x[i]+a1_v1_13;
          a1_x[i-n_Tau]=a1_x[i-n_Tau]+a1_v1_12;
          a1_u[20]=a1_u[20]+a1_v1_11;
          a1_v1_0=a1_v1_10; a1_v1_9=0-a1_v1_10;
          a1_v1_6=1/v1_8*a1_v1_9; a1_v1_8=0-v1_6/(v1_8*v1_8)*a1_v1_9;
          a1_v1_7=a1_v1_8;
          a1_x[15]=a1_x[15]+a1_v1_7;
          a1_v1_1=v1_5*a1_v1_6; a1_v1_5=v1_1*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
          a1_x[i-1]=a1_x[i-1]+a1_v1_3;
          a1_x[i]=a1_x[i]+a1_v1_2;
          a1_u[14]=a1_u[14]+a1_v1_1;
        }
        if (cs[cs_c]==12) {
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+2*n_Theta+2*n_Tau]=fds[fds_c];
          v1_0=x[16+n_T+2*n_Theta+2*n_Tau];
          v1_1=x[8];
          v1_2=v1_0-v1_1;
          // adjoint assignment
          a1_v1_2=a1_f[16+n_T+2*n_Theta+2*n_Tau]; a1_f[16+n_T+2*n_Theta+2*n_Tau]=0;
          a1_v1_0=a1_v1_2; a1_v1_1=0-a1_v1_2;
          a1_x[8]=a1_x[8]+a1_v1_1;
          a1_x[16+n_T+2*n_Theta+2*n_Tau]=a1_x[16+n_T+2*n_Theta+2*n_Tau]+a1_v1_0;
          // incomplete SAC
          fds_c=fds_c-1; f[16+n_T+2*n_Theta+3*n_Tau-1]=fds[fds_c];
          v1_0=0;
          v1_1=u[14];
          v1_2=x[16+n_T+2*n_Theta+3*n_Tau-1];
          v1_3=x[16+n_T+2*n_Theta+3*n_Tau-2];
          v1_4=v1_2-v1_3;
          v1_5=v1_4;
          v1_6=v1_1*v1_5;
          v1_7=x[15];
          v1_8=v1_6/v1_7;
          v1_9=v1_0-v1_8;
          v1_10=u[20];
          v1_11=x[16+n_T+2*n_Theta+2*n_Tau-1];
          v1_12=x[16+n_T+2*n_Theta+3*n_Tau-1];
          v1_13=v1_11-v1_12;
          v1_14=v1_13;
          v1_15=v1_10*v1_14;
          v1_16=v1_9+v1_15;
          // adjoint assignment
          a1_v1_16=a1_f[16+n_T+2*n_Theta+3*n_Tau-1]; a1_f[16+n_T+2*n_Theta+3*n_Tau-1]=0;
          a1_v1_9=a1_v1_16; a1_v1_15=a1_v1_16;
          a1_v1_10=v1_14*a1_v1_15; a1_v1_14=v1_10*a1_v1_15;
          a1_v1_13=a1_v1_14;
          a1_v1_11=a1_v1_13; a1_v1_12=0-a1_v1_13;
          a1_x[16+n_T+2*n_Theta+3*n_Tau-1]=a1_x[16+n_T+2*n_Theta+3*n_Tau-1]+a1_v1_12;
          a1_x[16+n_T+2*n_Theta+2*n_Tau-1]=a1_x[16+n_T+2*n_Theta+2*n_Tau-1]+a1_v1_11;
          a1_u[20]=a1_u[20]+a1_v1_10;
          a1_v1_0=a1_v1_9; a1_v1_8=0-a1_v1_9;
          a1_v1_6=1/v1_7*a1_v1_8; a1_v1_7=0-v1_6/(v1_7*v1_7)*a1_v1_8;
          a1_x[15]=a1_x[15]+a1_v1_7;
          a1_v1_1=v1_5*a1_v1_6; a1_v1_5=v1_1*a1_v1_6;
          a1_v1_4=a1_v1_5;
          a1_v1_2=a1_v1_4; a1_v1_3=0-a1_v1_4;
          a1_x[16+n_T+2*n_Theta+3*n_Tau-2]=a1_x[16+n_T+2*n_Theta+3*n_Tau-2]+a1_v1_3;
          a1_x[16+n_T+2*n_Theta+3*n_Tau-1]=a1_x[16+n_T+2*n_Theta+3*n_Tau-1]+a1_v1_2;
          a1_u[14]=a1_u[14]+a1_v1_1;
        }
      }
   }
   if (bmode_1==2) {
      rhs(f, x, u, n, m, n_T, n_Theta, n_Tau);
   }
}
